? .authorize.c.swp
Index: authorize.c
===================================================================
RCS file: /cvsroot/ser/sip_router/modules/auth_db/authorize.c,v
retrieving revision 1.21
diff -u -r1.21 authorize.c
--- authorize.c	2 Nov 2004 10:44:56 -0000	1.21
+++ authorize.c	12 Jan 2005 17:39:05 -0000
@@ -216,9 +216,18 @@
 					|| VAL_NULL(&(result->rows[0].values[1 + avps_int_n + i]))
 					|| memcmp(avps_str[i].s, "rpid", 4) != 0)
 				continue;
-			rpid.s = (char*)VAL_STRING(&(result->rows[0].values[1 + avps_int_n + i]));
-			if(rpid.s!=NULL)
-				rpid.len = strlen(rpid.s);
+			char * tmp = (char*)VAL_STRING(&(result->rows[0].values[1 + avps_int_n + i]));
+			if(tmp!=NULL) {
+				rpid.len = strlen(tmp);
+				rpid.s = pkg_malloc(rpid.len);
+				if (rpid.s == NULL) {
+					rpid.len = 0;
+					auth_dbf.free_result(db_handle, result);
+					LOG(L_ERR, "authorize(): Error while allocating memory for rpid\n");
+					return -1;
+				}
+				memcpy(rpid.s, tmp, rpid.len);
+			}
 		}
 		ret = post_auth_func(_m, h, &rpid);
 		switch(ret) {
